


local QBCore = nil
local ESX = nil
local inRace
local startTime = 0
local myAvatar,myName,myVehicle
local racedata
local currentBlip
local oneplayer = 0
local timestart = false
local nextpointtime = 0
local currentCheckpoint,totalCheckPoints
local TriggerCallback
local CurrentFramework

if GetFrameWork() == 'ESXNEW' then
    ESX = exports['es_extended']:getSharedObject()
    Citizen.CreateThread(function()
        while ESX.GetPlayerData().job == nil do
          Citizen.Wait(10)
        end
        ESX.PlayerData = ESX.GetPlayerData()
    end)
    TriggerCallback = function (name, cb, ...) 
        ESX.TriggerServerCallback(name, cb, ...)
    end
elseif GetFrameWork() == 'QBCORE' then
    QBCore = exports['qb-core']:GetCoreObject()
    TriggerCallback = function (name, cb, ...) 
        QBCore.Functions.TriggerCallback(name, cb, ...)
    end
elseif GetFrameWork() == 'ESX' then
    while ESX == nil do
		TriggerEvent('esx:getSharedObject', function(obj) ESX = obj end)
		Citizen.Wait(500)
	end
    TriggerCallback = function (name, cb, ...) 
        ESX.TriggerServerCallback(name, cb, ...)
    end
end



function DrawNextCheckPoint()
    local currentRace = racedata
    local startTime = GetGameTimer()
    local timeLimit = Config.LevelCheckPoint[currentRace.level] or error('Error For Level Race')
    currentCheckpoint, totalCheckPoints = 1, #currentRace.laps
    SetCheckPointBlip(currentRace.laps[currentCheckpoint])

    while currentCheckpoint <= totalCheckPoints do
        Citizen.Wait(0)

        local playerPed, playerCoords = PlayerPedId(), GetEntityCoords(PlayerPedId())
        local distance = #(playerCoords - currentRace.laps[currentCheckpoint])
        local currentTime = GetGameTimer()
        local timeLeft = (timeLimit - (currentTime - startTime)) / 1000
        local minutes, seconds = math.floor(timeLeft / 60), math.floor(timeLeft % 60)
        local displayTime = string.format("%02d:%02d", minutes, seconds)
        DrawMarker(1, currentRace.laps[currentCheckpoint], 0.0, 0.0, 0.0, 0.0, 0.0,  60.0, 7.0, 7.0, 7.0, 100, 255, 100, 100, false, false, 2, false, nil, nil, false)
        if distance <  4.0 then
            PlaySoundFrontend(-1, 'CHECKPOINT_NORMAL', 'HUD_MINI_GAME_SOUNDSET', false)
            currentCheckpoint = currentCheckpoint + 1
            SetCheckPointBlip(currentRace.laps[currentCheckpoint], currentCheckpoint == totalCheckPoints + 1)
            startTime = GetGameTimer()
        elseif currentTime - startTime >= timeLimit then
            SetCheckPointBlip(currentRace.laps[currentCheckpoint], true)
            inRace, timeStart, myAvatar, carForRecord, myVehicle, myName, racedata = false
            PlaySoundFrontend(-1, "ScreenFlash", "MissionFailedSounds",false)
            Wait(5000)
            print('you cant')
            break
        end

        DrawTimerBar('To Next Lap', displayTime, 1, timeLeft <= 6 and 255 or 255, timeLeft <= 6 and 0 or 255, timeLeft <= 6 and 0 or 255)
    end

    if currentCheckpoint == totalCheckPoints + 1 then
        local finishTime, carForRecord = GetElapsedTime(), myVehicle
        TriggerServerEvent('ataRace:SavePlayerWhenFinished', finishTime, currentRace.raceName, myName, carForRecord, myAvatar)
        TriggerCallback('ataRace:GetHighRecordAfterFinishRace', function(data)
            SendNUIMessage({
                action = 'finish',
                finishinformation = {
                    vehiclename = carForRecord,
                    time = finishTime,
                    high = data.score,
                },
            })
        end, currentRace.raceName)
    end
        inRace, timeStart, myAvatar, carForRecord, myVehicle, myName, racedata = false
end

function SetCheckPointBlip(checkpoint, removeall)
    if removeall then
        RemoveBlip(currentBlip)
        currentBlip = nil
    else
        if DoesBlipExist(currentBlip) then
            RemoveBlip(currentBlip)
        end

        if not checkpoint then
            return
        end

        local blip = AddBlipForCoord(checkpoint)

        BeginTextCommandSetBlipName("STRING")
        AddTextComponentString("Checkpoint")
        EndTextCommandSetBlipName(blip)

        SetBlipRoute(blip, true)

        currentBlip = blip
    end
end
    




RegisterNetEvent('ataRace:SendInformationRaceLocation')
AddEventHandler('ataRace:SendInformationRaceLocation', function(information,raceinformation,myinfo,avatar,myname)
    
    local profile = {
        myname = myname,
        myavatar = avatar
    }
    if myinfo ~= nil then
         profile = {
            myrecord = myinfo.score,
            myvehicle = myinfo.car,
            myname = myname,
            myavatar = avatar
        }
    end
    local raceinfo = {
        location = raceinformation.raceName,
        image = raceinformation.raceImage
    }

    if not information[1] == nil then
    oneplayer = ConvertMillisecondsToString(information[1].score)
    end
    
    SetNuiFocus(true,true)
    SendNUIMessage({
        action = 'ui',
        info = information,
        profile = profile,
        raceinfo = raceinfo
    })
end)


Citizen.CreateThread(function()
    -- Load textures
    RequestStreamedTextureDict('raceflag', true)
    RequestStreamedTextureDict('world_blips', true)
    while not HasStreamedTextureDictLoaded('raceflag') or not HasStreamedTextureDictLoaded('world_blips') do
        Wait(0)
    end


function canRace(race)
    local player = PlayerPedId()
    local vehicle = GetVehiclePedIsUsing(player)
    local vehicleModel = GetEntityModel(vehicle)
    local carName = GetDisplayNameFromVehicleModel(vehicleModel)
    myVehicle = carName
    SendNUIMessage({
        action = 'sendInformation',
        nowVehicle = carName
    })

    if #race.availableVehicle == 0 then
        return true
    end
    for i, availableCar in ipairs(race.availableVehicle) do
        if string.lower(carName) == string.lower(availableCar) then
            return true
        end
    end
    return false
end

function GetCurrentLap()
    return currentCheckpoint 
end

function GetTotalLaps()
    return totalCheckPoints
end


function StartTimer()
    startTime = GetGameTimer()
end

function GetElapsedTimeString()
    
    local currentTime = GetGameTimer()
    local elapsedTime = currentTime - startTime
    local minutes = math.floor(elapsedTime / 60000)
    local seconds = math.floor((elapsedTime % 60000) / 1000)
    local milliseconds = elapsedTime % 1000
    local timeString = string.format("%02d:%02d:%d", minutes, seconds, math.floor(milliseconds / 100))
    return timeString
end

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        sleep = true
        if inRace then
            sleep = false
            drawleft()
        end
        if sleep then Wait(1000) end
    end
end)



function drawleft()
    if oneplayer ~= 0 then
        DrawTimerBar('1st Record', oneplayer , 4,255,255,255)
    end
    if timestart then
    DrawTimerBar('Time', GetElapsedTimeString() , 3,255,255,255)
    DrawTimerBar('Lap', ('%s / %s'):format(GetCurrentLap(), GetTotalLaps()), 2,255,255,255)
    end
    --  DrawTimerBar('label', nextpointtime, 1)
end


function ConvertMillisecondsToString(ms)
    local minutes = math.floor(ms / 60000)
    local seconds = math.floor((ms % 60000) / 1000)
    local milliseconds = ms % 1000
    local timeString = string.format("%02d:%02d:%d", minutes, seconds, math.floor(milliseconds / 100))
    return timeString
end




function GetElapsedTime()
    local currentTime = GetGameTimer()
    local elapsedTime = currentTime - startTime
    return elapsedTime
end

RegisterNUICallback('ExitUI', function(data, cb)
    SetNuiFocus(false,false)
    racedata = nil
end)

RegisterNUICallback('StartRace', function(data, cb)
    TriggerServerEvent('ataRace:CheckCoolDownInServerSide',racedata.raceName)
    
    myAvatar = data.avatar
    myName = data.name
end)


RegisterNetEvent('ataRace:displayCooldown')
AddEventHandler('ataRace:displayCooldown', function(min,sec)
    print('min '..min,'sec'..sec)
    
end)


RegisterNetEvent('ataRace:CoolDownError')
AddEventHandler('ataRace:CoolDownError', function()
    SetNuiFocus(false,false)
    racedata = nil
end)



RegisterNetEvent('ataRace:StartRace')
AddEventHandler('ataRace:StartRace', function()
    TriggerServerEvent('ataRace:startCoolDown',racedata.raceName)
    SetNuiFocus(false,false)
    DoScreenFadeOut(1000)
    Wait(1000)
    vehicleSpawn(racedata.raceVehicleSpawn)
    CreateCam(true)
    Wait(2000)
    DoScreenFadeIn(1009)
    DrawCoolDown()
    inRace = true
    Wait(1000)
    timestart = true
    StartTimer()
    DrawNextCheckPoint()
end)


function DrawCoolDown()
    local scaleform = Scaleform.Request('COUNTDOWN')
    Wait(3000)
    DrawCountDownScaleform(scaleform, 1, 0.6, 200, 240, 20)
    Wait(1000)
    DrawCountDownScaleform(scaleform, 2, 0.6, 0, 240, 20)
    Wait(1000)
    DrawCountDownScaleform(scaleform, 3, 0.6, 240, 240, 20)
    Wait(1000)
    DrawCountDownScaleform(scaleform, 0, 0.6, 240, 240, 20)
    CreateCam(false)
end
DoScreenFadeIn(1009)

function vehicleSpawn(locations)
    local player = PlayerId()
    local vehicle = GetVehiclePedIsUsing(PlayerPedId())

    if DoesEntityExist(vehicle) and IsEntityAVehicle(vehicle) then

    local spawnLocation = locations[math.random(#locations)]
    SetEntityCoords(vehicle, spawnLocation.x, spawnLocation.y, spawnLocation.z)
    SetEntityHeading(vehicle, spawnLocation.w)
    else
    print('you dont have vehicle')
    end
end


CreateCam = function(valid)
    local playerPed = PlayerPedId()
    local playerVeh = GetVehiclePedIsIn(playerPed, false)
	if valid then
        FreezeEntityPosition(playerVeh,true)
	    local customVehicle = playerVeh
	    SetVehicleOnGroundProperly(customVehicle)
	    local vehPos = GetEntityCoords(customVehicle)
	    local camPos = GetOffsetFromEntityInWorldCoords(customVehicle, -3.0, -5.0, 3.0)
	    local headingToObject = GetHeadingFromVector_2d(vehPos.x - camPos.x, vehPos.y - camPos.y)
	    local cam = CreateCamWithParams('DEFAULT_SCRIPTED_CAMERA', camPos.x, camPos.y, camPos.z - 2.2, -2.0, 0.0, headingToObject - 5, GetGameplayCamFov(), false, 2)
	    SetCamActive(cam, true)
	    DisplayHud(false)
	    DisplayRadar(false)
	    RenderScriptCams(true, true, 1000, true, true)
	else
		RenderScriptCams(false, true , 500 , false , false)
		DestroyAllCams(true)
		ClearFocus()
		DisplayHud(true)
		DisplayRadar(true)
        FreezeEntityPosition(playerVeh,false)
	end
end


print(QBCore)

-- Citizen.CreateThread(function()
--     -- Load the textures
--     RequestStreamedTextureDict("world_blips", 1)
--     while not HasStreamedTextureDictLoaded("world_blips") do
--         Wait(0)
--     end

--     -- Add the Observatory blip
--     local blip = AddBlipForCoord(-422.399750,1135.010986,325.854462)
--     SetBlipSprite(blip, 378)
--     SetBlipColour(blip, 3)

--     -- Add all the cool info to the blip
--     SetBlipInfoTitle(blip, "illegal", false)
--     AddBlipInfoText(blip, "Rating", "85%")
--     SetBlipInfoImage(blip, "world_blips", "illegal")
--     AddBlipInfoName(blip, "Created by", "Rockstar") 
--     AddBlipInfoText(blip, "Rank", "25")
--     AddBlipInfoText(blip, "Players", "4 - 8")
--     AddBlipInfoText(blip, "Teams", "2")
--     AddBlipInfoIcon(blip, "Type", "Team Deathmatch", 4, 9, false)   
--     AddBlipInfoText(blip, "Area", "Galileo Observatory")
--     AddBlipInfoHeader(blip, "") -- Empty header adds the header line
--     AddBlipInfoText(blip, "See if your stars are in alignment with this deathmatch at the Galileo Observatory. Great for tourists or folks taking a break from cruising young bucks in the Gal...")
-- end)
